//
// 
//

#include "AvailableWindowSet.h"
#include "Pattern.h"


AvailableWindowSet::AvailableWindowSet() {
    windowSet = WindowSet();
}

WindowSet &AvailableWindowSet::getWindowSet() {
    return windowSet;
}

WindowSet AvailableWindowSet::getAugmentedWindowSet(WindowSet& addition) {
    WindowSet augmentedWindowSet = windowSet;
    extendWindowSet(augmentedWindowSet, addition);
    return augmentedWindowSet;
}



void AvailableWindowSet::addToWindowSet(WindowSet& addition) {
    extendWindowSet(windowSet, addition);
}

void AvailableWindowSet::removeWindowsOfPattern(int id) {
    for (auto it = windowSet.begin(); it != windowSet.end();){
        if (it->getPattern()->getId() == id){
            it = windowSet.erase(it);
        }else{
            it++;
        }
    }
}

void AvailableWindowSet::changePatterns(Pattern* from, Pattern* to) {
    for (auto it = windowSet.begin(); it != windowSet.end();it++){
        if (it->getPattern()->getId() == from->getId()){
            it->changePattern(to);
        }
    }
}

void AvailableWindowSet::extendWindowSet(WindowSet &windowSet, WindowSet addition) {
    windowSet.merge(addition);
//    auto addition_it = addition.begin();
//    for (auto it = windowSet.begin(); it != windowSet.end();){
//        if (*addition_it < *it){
//            it = windowSet.splice(it, *addition_it);
//            addition_it++;
//        }else{
//            it++;
//        }
//    }
//    // insert remaining symbols
//    windowSet.insert(windowSet.end(), addition_it, addition.end());
}

void AvailableWindowSet::print() {
    for (auto w:windowSet){
        std::cout << w.getPattern()->getId() << std::endl;
    }
}


