//
// 
//
#include "SequDatabase.h"


SequDatabase::SequDatabase(const std::string& filePath) {
    FILE* f = fopen(filePath.c_str() , "r");
    int ed; // event digit
    sequence first_sequence;
    sequence& current_sequence = first_sequence;

    int sequ_counter = 0;
    int event_in_sequ_counter = 0;

    while (fscanf(f,"%d", &ed) == 1){
        if (ed == -1){
            data.push_back(current_sequence);
            sequence next_sequence;
            current_sequence = next_sequence;
            sequ_counter++;
            event_in_sequ_counter = 0;
        }
        else{
            if (ed > highest_observed_event){
                highest_observed_event = ed;
                invertedIndex.resize(highest_observed_event+1);
            }
            current_sequence.push_back(ed);
            invertedIndex[ed].push_back(DataIndex(sequ_counter,event_in_sequ_counter));
            event_in_sequ_counter++;
        }
    }

    last_location = DataIndex(sequ_counter,event_in_sequ_counter);
}

int SequDatabase::size() {
    return data.size();
}

sequence& SequDatabase::getSequence(int n) {
    return data[n];
}

int SequDatabase::getHighestEvent() {
    return highest_observed_event;
}

location_list& SequDatabase::getLocationsOfEvent(int event) {
    return invertedIndex[event];
}

DataIndex SequDatabase::getLastLocation() {
    return last_location;
}

int SequDatabase::getEvent(DataIndex di) {
    return data[di.sequence_id][di.event_id];
}
