//
// 
//


#ifndef META_SEQUDATABASE_H
#define META_SEQUDATABASE_H

#include "iostream"
#include "stdio.h"
#include "vector"
#include "list"


#include "DataContainers.h"

typedef std::vector<int> sequence;
typedef std::vector<sequence> sequence_db;
typedef std::list<DataIndex> location_list;
typedef std::vector<location_list> inverted_index;

class SequDatabase {
public:
    SequDatabase(const std::string&);

    int size();
    sequence& getSequence(int n);
    int getHighestEvent();

    location_list& getLocationsOfEvent(int event);
    DataIndex getLastLocation();

    int getEvent(DataIndex di);

private:
    sequence_db data;
    int highest_observed_event = -1;
    inverted_index invertedIndex;
    DataIndex last_location = DataIndex(-1,-1);
};


#endif //META_SEQUDATABASE_H
