//
// 
//

#include "Window.h"
#include "Pattern.h"
//Window::Window(Pattern &pattern, DataIndex start, DataIndex end) {
//
//}
Window::Window(Pattern *pattern, std::vector<DataIndex> positions) : pattern(pattern), positions(positions) {

}

std::vector<DataIndex> &Window::getPositions() {
    return positions;
}

bool Window::operator<(const Window &rhs) const {
    return (positions[0] < rhs.positions[0]);
}
bool Window::operator>(const Window &rhs) const {
    return (positions[0] > rhs.positions[0]);
}

Pattern* Window::getPattern() {
    return pattern;
}

DataIndex Window::getLastPosition() {
    return *(--positions.end());
}

DataIndex Window::getFirstPosition() {
    return positions.front();
}

void Window::print() {
    std::cout << "Pattern Id: " << pattern->getId() << " Positions: ";
    for (DataIndex di:positions){
        std::cout << di.sequence_id << "," << di.event_id << "  ";
    }
    std::cout << std::endl;
}

int Window::getGapCount() {
    return getLastPosition()-getFirstPosition() - (pattern->getEvents().size()-1);
}

Window &Window::operator=(const Window &window) {
    positions = window.positions;
    pattern = window.pattern;
    return *this;
}

void Window::changePattern(Pattern *p) {
    pattern = p;
}

bool Window::operator==(const Window &rhs) const {
    if (positions.size() == rhs.positions.size()){
        for (int i = 0; i < positions.size(); i++){
            if (!(positions[i] == rhs.positions[i])){
                return false;
            }
        }
        return true;
    }else{
        return false;
    }
}

bool Window::operator!=(const Window &rhs) const {
    return !operator==(rhs);
}
