//
// 
//


#ifndef META_WINDOW_H
#define META_WINDOW_H

//#include "Pattern.h"
#include "DataContainers.h"
#include "vector"

class Pattern;
class Window {
public:
    Window(Pattern* pattern, std::vector<DataIndex> positions);
    std::vector<DataIndex>& getPositions();
    DataIndex getLastPosition();
    DataIndex getFirstPosition();
    bool operator<(const Window& rhs) const;
    bool operator>(const Window& rhs) const;
    bool operator==(const Window& rhs) const;
    bool operator!=(const Window& rhs) const;
    Pattern* getPattern();
    void changePattern(Pattern* p);
    int getGapCount();
    void print();
    Window& operator=(const Window& window);

private:
    Pattern* pattern;
    std::vector<DataIndex> positions;
};


#endif //META_WINDOW_H
